;; Turtle.lsp - graphics demo for newLISP-tk
;;
;; to run: (Turtle:run)
;;
;; 1.1 changed floats to integers in (draw) to make it work 
;;     in locales, which use the decimal comma, which confuses Tcl/Tk
;;
;;
;;


(context 'Turtle)

(set 'color "blue")

(set 'direction -425.6857918)

(define (dragon sign level)
  (if (= 0 level) 
   (turtle-forward 4) 
   (begin 
    (dec 'level) 
    (turtle-right (sign 45)) 
    (dragon - level) 
    (turtle-left (sign 90)) 
    (dragon + level) 
    (turtle-right (sign 45)))))

(define (dragon-curve n clr)
  (set 'color clr)
  (dragon + n))

(define (draw )
  (tk ".tw.can create line " (join (map string points) " ") " -fill " 
   color)
  (tk "update idletasks")
  (set 'points (list newX newY)))

(define (draw-rect n)
  (turtle-forward n)
  (turtle-right 90)
  (turtle-forward n)
  (turtle-right 90)
  (turtle-forward n)
  (turtle-right 90)
  (turtle-forward n))

(define (draw-squirl n)
  (dotimes (x (/ n 3)) 
   (turtle 'forward n) 
   (turtle 'right 90) 
   (set 'n (- n 2)))
  (turtle-go-to 0 0))

(set 'lastX 120)

(set 'lastY 200)

(set 'newX 120)

(set 'newY 200)

(define (rose clr)
  (set 'color clr)
  (dotimes (x 90) 
   (draw-rect 60) 
   (turtle-right 2)))

(define (run )
  (tk "if {[winfo exists .tw] == 1} {destroy .tw}")
  (tk "toplevel .tw")
  (tk "canvas .tw.can -width 500 -height 400 -bg #FFFEC0")
  (tk "pack .tw.can")
  (tk "wm geometry .tw +100+160")
  (tk "wm title .tw { Turtle.lsp}")
  (tk ".tw.can create text 380 70 -fill navy -font {Times 12} -text {Dragon Fractal}")
  (tk ".tw.can create text 100 350 -fill navy -font {Times 16} -text {Turtle Graphics}")
  (tk "after 300; update idletasks")
  (turtle-start 300 50)
  (dragon-curve 12 "red")
  (draw)
  (turtle-start 120 200)
  (rose "blue"))

(define (turtle-center )
  (set 'lastX 150)
  (set 'lastY 60)
  (set 'newX 150)
  (set 'newY 60)
  (set 'direction 1.570796327))

(define (turtle-forward d)
  (set 'newX (add lastX (mul (cos direction) d)))
  (set 'newY (add lastY (mul (sin direction) d)))
  (push newX points -1)
  (push newY points -1)
  (if (= (length points) 100) 
   (draw))
  (set 'lastX newX)
  (set 'lastY newY))

(define (turtle-go-to x y)
  (set 'lastX x)
  (set 'lastY y))

(define (turtle-left d)
  (set 'direction (add direction (mul d 0.017453292))))

(define (turtle-right d)
  (set 'direction (sub direction (mul d 0.017453292))))

(define (turtle-start x y)
  (set 'lastX x)
  (set 'lastY y)
  (set 'newX x)
  (set 'newY y)
  (set 'points (list x y))
  (set 'direction 1.570796327))

(set 'x 0)


(context 'MAIN)

(Turtle:run)
